// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/files -i Files -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/files"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements files.Files that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   files.Files
}

// AccessLoggingMiddleware instruments an implementation of the files.Files with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next files.Files) files.Files {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) AbortUpload(ctx context.Context, upload *files.MultipartUpload) (err error) {
	begin := time.Now()

	m.logger.Debug("AbortUpload.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("upload", upload),
	)

	err = m.next.AbortUpload(ctx, upload)

	m.logger.Debug("AbortUpload.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) CompleteUpload(ctx context.Context, upload *files.MultipartUpload) (u *files.MultipartUpload, err error) {
	begin := time.Now()

	m.logger.Debug("CompleteUpload.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("upload", upload),
	)

	u, err = m.next.CompleteUpload(ctx, upload)

	m.logger.Debug("CompleteUpload.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("u", u),
		zap.Error(err),
	)

	return u, err
}

func (m *accessLoggingMiddleware) DeleteFile(ctx context.Context, file *files.File) (err error) {
	begin := time.Now()

	m.logger.Debug("DeleteFile.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("file", file),
	)

	err = m.next.DeleteFile(ctx, file)

	m.logger.Debug("DeleteFile.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) GetFile(ctx context.Context, file *files.File) (f *files.File, err error) {
	begin := time.Now()

	m.logger.Debug("GetFile.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("file", file),
	)

	f, err = m.next.GetFile(ctx, file)

	m.logger.Debug("GetFile.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("f", f),
		zap.Error(err),
	)

	return f, err
}

func (m *accessLoggingMiddleware) MoveUpload(ctx context.Context, upload *files.MultipartUpload) (file *files.File, err error) {
	begin := time.Now()

	m.logger.Debug("MoveUpload.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("upload", upload),
	)

	file, err = m.next.MoveUpload(ctx, upload)

	m.logger.Debug("MoveUpload.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("file", file),
		zap.Error(err),
	)

	return file, err
}

func (m *accessLoggingMiddleware) StartUpload(ctx context.Context, upload *files.MultipartUpload) (u *files.MultipartUpload, err error) {
	begin := time.Now()

	m.logger.Debug("StartUpload.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("upload", upload),
	)

	u, err = m.next.StartUpload(ctx, upload)

	m.logger.Debug("StartUpload.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("u", u),
		zap.Error(err),
	)

	return u, err
}

func (m *accessLoggingMiddleware) Upload(ctx context.Context, file *files.File) (u *files.Upload, err error) {
	begin := time.Now()

	m.logger.Debug("Upload.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("file", file),
	)

	u, err = m.next.Upload(ctx, file)

	m.logger.Debug("Upload.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("u", u),
		zap.Error(err),
	)

	return u, err
}
