package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/references"
	"git.perx.ru/perxis/perxis-go/pkg/references/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/references"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc references.References, opts ...grpckit.ServerOption) pb.ReferencesServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		GetEndpoint:     grpcerr.ServerMiddleware(eps.GetEndpoint),
		PublishEndpoint: grpcerr.ServerMiddleware(eps.PublishEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
